<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.6"/>
<title>TIML: timlUtil.h File Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/search.js"></script>
<script type="text/javascript">
  $(document).ready(function() { searchBox.OnSelectItem(0); });
</script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td style="padding-left: 0.5em;">
   <div id="projectname">TIML
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.6 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search",false,'Search');
</script>
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="annotated.html"><span>Data&#160;Structures</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li>
        <div id="MSearchBox" class="MSearchBoxInactive">
        <span class="left">
          <img id="MSearchSelect" src="search/mag_sel.png"
               onmouseover="return searchBox.OnSearchSelectShow()"
               onmouseout="return searchBox.OnSearchSelectHide()"
               alt=""/>
          <input type="text" id="MSearchField" value="Search" accesskey="S"
               onfocus="searchBox.OnSearchFieldFocus(true)" 
               onblur="searchBox.OnSearchFieldFocus(false)" 
               onkeyup="searchBox.OnSearchFieldChange(event)"/>
          </span><span class="right">
            <a id="MSearchClose" href="javascript:searchBox.CloseResultsWindow()"><img id="MSearchCloseImg" border="0" src="search/close.png" alt=""/></a>
          </span>
        </div>
      </li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>Globals</span></a></li>
    </ul>
  </div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
<a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(0)"><span class="SelectionMark">&#160;</span>All</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(1)"><span class="SelectionMark">&#160;</span>Data Structures</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(2)"><span class="SelectionMark">&#160;</span>Files</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(3)"><span class="SelectionMark">&#160;</span>Functions</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(4)"><span class="SelectionMark">&#160;</span>Variables</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(5)"><span class="SelectionMark">&#160;</span>Enumerations</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(6)"><span class="SelectionMark">&#160;</span>Enumerator</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(7)"><span class="SelectionMark">&#160;</span>Groups</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(8)"><span class="SelectionMark">&#160;</span>Pages</a></div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_4f218e5c1c68a8760266841df915118e.html">src</a></li><li class="navelem"><a class="el" href="dir_e5def28db4ba0142cedf1af2d851f321.html">common</a></li><li class="navelem"><a class="el" href="dir_3548040f51d72c8ca49dee5213e206f2.html">util</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="summary">
<a href="#nested-classes">Data Structures</a> &#124;
<a href="#define-members">Macros</a> &#124;
<a href="#enum-members">Enumerations</a> &#124;
<a href="#func-members">Functions</a>  </div>
  <div class="headertitle">
<div class="title">timlUtil.h File Reference</div>  </div>
</div><!--header-->
<div class="contents">
<div class="textblock"><code>#include &lt;stdlib.h&gt;</code><br/>
<code>#include &lt;stdio.h&gt;</code><br/>
<code>#include &lt;stdint.h&gt;</code><br/>
<code>#include &lt;stdbool.h&gt;</code><br/>
<code>#include &lt;float.h&gt;</code><br/>
<code>#include &lt;string.h&gt;</code><br/>
<code>#include &lt;math.h&gt;</code><br/>
<code>#include &lt;time.h&gt;</code><br/>
<code>#include &lt;dirent.h&gt;</code><br/>
<code>#include &lt;omp.h&gt;</code><br/>
<code>#include &lt;unistd.h&gt;</code><br/>
<code>#include &lt;libgen.h&gt;</code><br/>
<code>#include &quot;jpeglib.h&quot;</code><br/>
<code>#include &quot;cblas.h&quot;</code><br/>
</div>
<p><a href="timlUtil_8h_source.html">Go to the source code of this file.</a></p>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="nested-classes"></a>
Data Structures</h2></td></tr>
<tr class="memitem:"><td class="memItemLeft" align="right" valign="top">struct &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structtimlUtilImage.html">timlUtilImage</a></td></tr>
<tr class="separator:"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:"><td class="memItemLeft" align="right" valign="top">struct &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structtimlUtilInitializer.html">timlUtilInitializer</a></td></tr>
<tr class="separator:"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:"><td class="memItemLeft" align="right" valign="top">struct &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structtimlUtilImageSet.html">timlUtilImageSet</a></td></tr>
<tr class="separator:"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="define-members"></a>
Macros</h2></td></tr>
<tr class="memitem:gaa800319c343d51dcc2ba62246ad298af"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="gaa800319c343d51dcc2ba62246ad298af"></a>
#define&#160;</td><td class="memItemRight" valign="bottom"><b>TIML_UTIL_MAX_STR</b>&#160;&#160;&#160;100</td></tr>
<tr class="separator:gaa800319c343d51dcc2ba62246ad298af"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga775af8da42e4c88c8c19afb00b273654"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="ga775af8da42e4c88c8c19afb00b273654"></a>
#define&#160;</td><td class="memItemRight" valign="bottom"><b>TIML_UTIL_PI</b>&#160;&#160;&#160;3.14159265358979323846</td></tr>
<tr class="separator:ga775af8da42e4c88c8c19afb00b273654"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga070b6e6e97816b6fcfd3dee857484693"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="ga070b6e6e97816b6fcfd3dee857484693"></a>
#define&#160;</td><td class="memItemRight" valign="bottom"><b>ERROR_UTIL_OFFSET</b>&#160;&#160;&#160;3000</td></tr>
<tr class="separator:ga070b6e6e97816b6fcfd3dee857484693"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="enum-members"></a>
Enumerations</h2></td></tr>
<tr class="memitem:gad571717cf97615bd28081e15b4561fb5"><td class="memItemLeft" align="right" valign="top">enum &#160;</td><td class="memItemRight" valign="bottom"><b>timlUtilError</b> { <br/>
&#160;&#160;<b>ERROR_UTIL_NULL_PTR</b> = ERROR_UTIL_OFFSET, 
<b>ERROR_UTIL_MNIST_TRAINING_DATA_READING</b>, 
<b>ERROR_UTIL_MNIST_TRAINING_DATA_ALLOCATION</b>, 
<b>ERROR_UTIL_MNIST_TRAINING_LABEL_READING</b>, 
<br/>
&#160;&#160;<b>ERROR_UTIL_MNIST_TRAINING_LABEL_ALLOCATION</b>, 
<b>ERROR_UTIL_MNIST_TESTING_DATA_READING</b>, 
<b>ERROR_UTIL_MNIST_TESTING_DATA_ALLOCATION</b>, 
<b>ERROR_UTIL_MNIST_TESTING_LABEL_READING</b>, 
<br/>
&#160;&#160;<b>ERROR_UTIL_MNIST_TESTING_LABEL_ALLOCATION</b>, 
<b>ERROR_UTIL_CIFAR10_TRAINING_READING</b>, 
<b>ERROR_UTIL_CIFAR10_TRAINING_ALLOCATION</b>, 
<b>ERROR_UTIL_CIFAR10_TESTING_READING</b>, 
<br/>
&#160;&#160;<b>ERROR_UTIL_CIFAR10_TESTING_ALLOCATION</b>, 
<b>ERROR_UTIL_CIFAR100_TRAINING_READING</b>, 
<b>ERROR_UTIL_CIFAR100_TRAINING_ALLOCATION</b>, 
<b>ERROR_UTIL_CIFAR100_TESTING_READING</b>, 
<br/>
&#160;&#160;<b>ERROR_UTIL_CIFAR100_TESTING_ALLOCATION</b>, 
<b>ERROR_UTIL_READ_FLOAT_MATRIX</b>, 
<b>ERROR_UTIL_READ_INT_MATRIX</b>, 
<b>ERROR_UTIL_READ_FLOAT_VECTOR</b>, 
<br/>
&#160;&#160;<b>ERROR_UTIL_READ_INT_VECTOR</b>, 
<b>ERROR_UTIL_WRITE_FLOAT_MATRIX</b>, 
<b>ERROR_UTIL_WRITE_INT_MATRIX</b>, 
<b>ERROR_UTIL_WRITE_FLOAT_VECTOR</b>, 
<br/>
&#160;&#160;<b>ERROR_UTIL_WRITE_INT_VECTOR</b>, 
<b>ERROR_UTIL_MALLOC</b>, 
<b>ERROR_UTIL_JPEG_READING</b>
<br/>
 }</td></tr>
<tr class="separator:gad571717cf97615bd28081e15b4561fb5"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:gad605701ea044242abd13eac42194bb29"><td class="memItemLeft" align="right" valign="top">enum &#160;</td><td class="memItemRight" valign="bottom"><b>timlUtilActivationType</b> { <br/>
&#160;&#160;<b>Util_Sigmoid</b>, 
<b>Util_Softmax</b>, 
<b>Util_Softplus</b>, 
<b>Util_Relu</b>, 
<br/>
&#160;&#160;<b>Util_Nrelu</b>, 
<b>Util_Tanh</b>, 
<b>Util_Linear</b>
<br/>
 }</td></tr>
<tr class="separator:gad605701ea044242abd13eac42194bb29"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga3bfdd4453df8afd1addfe23489d86f09"><td class="memItemLeft" align="right" valign="top">enum &#160;</td><td class="memItemRight" valign="bottom"><b>timlUtilCostFunctionType</b> { <b>Util_CrossEntropy</b>, 
<b>Util_MSE</b>
 }</td></tr>
<tr class="separator:ga3bfdd4453df8afd1addfe23489d86f09"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga4f914372aedf08ba56b8158727b558d8"><td class="memItemLeft" align="right" valign="top">enum &#160;</td><td class="memItemRight" valign="bottom"><b>timlUtilConvType</b> { <b>Util_Conv2D</b>, 
<b>Util_Corr2D</b>
 }</td></tr>
<tr class="separator:ga4f914372aedf08ba56b8158727b558d8"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga8e44b2a87636024736da04ae5a53c1c9"><td class="memItemLeft" align="right" valign="top">enum &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__util.html#ga8e44b2a87636024736da04ae5a53c1c9">timlUtilParamsLevel</a> { <a class="el" href="group__util.html#gga8e44b2a87636024736da04ae5a53c1c9a7a706ba3c48e3e4f1302c8fc5af3bb50">Util_ParamsLevel1</a>, 
<a class="el" href="group__util.html#gga8e44b2a87636024736da04ae5a53c1c9a2cddbb23ea76ecaee590b53dab026432">Util_ParamsLevel2</a>, 
<a class="el" href="group__util.html#gga8e44b2a87636024736da04ae5a53c1c9adfa1c162a9ac296e6e94e6a03b5ccef5">Util_ParamsLevel3</a>
 }</td></tr>
<tr class="separator:ga8e44b2a87636024736da04ae5a53c1c9"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga62247c3acaa170e3a75f9887ec21106f"><td class="memItemLeft" align="right" valign="top">enum &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__util.html#ga62247c3acaa170e3a75f9887ec21106f">timlUtilAllocatorLevel</a> { <a class="el" href="group__util.html#gga62247c3acaa170e3a75f9887ec21106fabaf43a2a2db7a39b88ca28b3fbdb9f8d">Util_AllocatorLevel1</a>, 
<a class="el" href="group__util.html#gga62247c3acaa170e3a75f9887ec21106fa852397275a536af52c736403647721c3">Util_AllocatorLevel2</a>, 
<a class="el" href="group__util.html#gga62247c3acaa170e3a75f9887ec21106faaa6f2cd7843572787572085b7bef172b">Util_AllocatorLevel3</a>
 }</td></tr>
<tr class="separator:ga62247c3acaa170e3a75f9887ec21106f"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga898df2504b88d834c373082f2aa9f537"><td class="memItemLeft" align="right" valign="top">enum &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__util.html#ga898df2504b88d834c373082f2aa9f537">timlUtilCropType</a> { <a class="el" href="group__util.html#gga898df2504b88d834c373082f2aa9f537ae92f4e5d3672f4d40cb213ac3a2210b3">Util_CenterCrop</a>, 
<a class="el" href="group__util.html#gga898df2504b88d834c373082f2aa9f537ac82205e1f2c21d90dbcccd0e8a7d0dc8">Util_RandomCrop</a>
 }</td></tr>
<tr class="separator:ga898df2504b88d834c373082f2aa9f537"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga5405b012e02035f4d864e0e38d516764"><td class="memItemLeft" align="right" valign="top">enum &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__util.html#ga5405b012e02035f4d864e0e38d516764">timlUtilMirrorType</a> { <a class="el" href="group__util.html#gga5405b012e02035f4d864e0e38d516764abfa2a07e6c5c6e74add533dfc9b548dd">Util_Mirror</a>, 
<a class="el" href="group__util.html#gga5405b012e02035f4d864e0e38d516764aa4b22e60f0d512a27496c274c01adab6">Util_NoMirror</a>, 
<a class="el" href="group__util.html#gga5405b012e02035f4d864e0e38d516764a8ece193f7f7681a69b4b286983583cfc">Util_RandomMirror</a>
 }</td></tr>
<tr class="separator:ga5405b012e02035f4d864e0e38d516764"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga24b8d631aa6d95132123f8ca8897b7dd"><td class="memItemLeft" align="right" valign="top">enum &#160;</td><td class="memItemRight" valign="bottom"><b>timlUtilInitializerType</b> { <b>Util_Constant</b>, 
<b>Util_Gaussian</b>, 
<b>Util_Uniform</b>, 
<b>Util_Xavier</b>
 }</td></tr>
<tr class="separator:ga24b8d631aa6d95132123f8ca8897b7dd"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:gacf64b66c7adbbbf408401e419d44c9f7"><td class="memItemLeft" align="right" valign="top">enum &#160;</td><td class="memItemRight" valign="bottom"><b>timlUtilPhase</b> { <b>Util_Train</b>, 
<b>Util_Test</b>, 
<b>Util_Debug</b>
 }</td></tr>
<tr class="separator:gacf64b66c7adbbbf408401e419d44c9f7"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="func-members"></a>
Functions</h2></td></tr>
<tr class="memitem:ga218c4e1b952545e65e70b46fc087c0fa"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__util.html#ga218c4e1b952545e65e70b46fc087c0fa">timlUtilReadMNIST</a> (const char *path, <a class="el" href="structtimlUtilImageSet.html">timlUtilImageSet</a> *training, <a class="el" href="structtimlUtilImageSet.html">timlUtilImageSet</a> *testing)</td></tr>
<tr class="memdesc:ga218c4e1b952545e65e70b46fc087c0fa"><td class="mdescLeft">&#160;</td><td class="mdescRight">Read MNIST database from binary files.  <a href="group__util.html#ga218c4e1b952545e65e70b46fc087c0fa">More...</a><br/></td></tr>
<tr class="separator:ga218c4e1b952545e65e70b46fc087c0fa"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga518889e2bee0ffe2a0bab1a2a509afeb"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__util.html#ga518889e2bee0ffe2a0bab1a2a509afeb">timlUtilReadCIFAR10</a> (const char *path, <a class="el" href="structtimlUtilImageSet.html">timlUtilImageSet</a> *training, <a class="el" href="structtimlUtilImageSet.html">timlUtilImageSet</a> *testing)</td></tr>
<tr class="memdesc:ga518889e2bee0ffe2a0bab1a2a509afeb"><td class="mdescLeft">&#160;</td><td class="mdescRight">Read CIFA10 database from binary files.  <a href="group__util.html#ga518889e2bee0ffe2a0bab1a2a509afeb">More...</a><br/></td></tr>
<tr class="separator:ga518889e2bee0ffe2a0bab1a2a509afeb"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:gad332b3fc9cca905cb073bb950c27d9a3"><td class="memItemLeft" align="right" valign="top">long&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__util.html#gad332b3fc9cca905cb073bb950c27d9a3">timlUtilDiffTime</a> (struct timespec start, struct timespec end)</td></tr>
<tr class="memdesc:gad332b3fc9cca905cb073bb950c27d9a3"><td class="mdescLeft">&#160;</td><td class="mdescRight">Return the time difference in micro second.  <a href="group__util.html#gad332b3fc9cca905cb073bb950c27d9a3">More...</a><br/></td></tr>
<tr class="separator:gad332b3fc9cca905cb073bb950c27d9a3"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga7b7056163efcce74e844159113ad7670"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__util.html#ga7b7056163efcce74e844159113ad7670">timlUtilRandDiscreteUniformRNG</a> (int a, int b)</td></tr>
<tr class="memdesc:ga7b7056163efcce74e844159113ad7670"><td class="mdescLeft">&#160;</td><td class="mdescRight">Discrete uniform random number generator in [a, b].  <a href="group__util.html#ga7b7056163efcce74e844159113ad7670">More...</a><br/></td></tr>
<tr class="separator:ga7b7056163efcce74e844159113ad7670"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga33ca8bcccfd95381c34a7822dd3d5e03"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__util.html#ga33ca8bcccfd95381c34a7822dd3d5e03">timlUtilRandContinuousUniformRNG</a> (float *x, int dim, float a, float b)</td></tr>
<tr class="memdesc:ga33ca8bcccfd95381c34a7822dd3d5e03"><td class="mdescLeft">&#160;</td><td class="mdescRight">Generate a discrete uniform random vector between (a, b)  <a href="group__util.html#ga33ca8bcccfd95381c34a7822dd3d5e03">More...</a><br/></td></tr>
<tr class="separator:ga33ca8bcccfd95381c34a7822dd3d5e03"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:gab0d103f2a7348ee3f7be2468cb06a374"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__util.html#gab0d103f2a7348ee3f7be2468cb06a374">timlUtilRandNormalRNG</a> (float *x, int dim, float mean, float std)</td></tr>
<tr class="memdesc:gab0d103f2a7348ee3f7be2468cb06a374"><td class="mdescLeft">&#160;</td><td class="mdescRight">Generate a Gaussian random number.  <a href="group__util.html#gab0d103f2a7348ee3f7be2468cb06a374">More...</a><br/></td></tr>
<tr class="separator:gab0d103f2a7348ee3f7be2468cb06a374"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga33f6226602545ae82fb9eb9dc4e2d0f4"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__util.html#ga33f6226602545ae82fb9eb9dc4e2d0f4">timlUtilRandPerm</a> (int *array, int n)</td></tr>
<tr class="memdesc:ga33f6226602545ae82fb9eb9dc4e2d0f4"><td class="mdescLeft">&#160;</td><td class="mdescRight">Random permute an array.  <a href="group__util.html#ga33f6226602545ae82fb9eb9dc4e2d0f4">More...</a><br/></td></tr>
<tr class="separator:ga33f6226602545ae82fb9eb9dc4e2d0f4"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga032c2a840544aee29ac1b36494bdfc6b"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__util.html#ga032c2a840544aee29ac1b36494bdfc6b">timlUtilFread</a> (void *ptr, size_t size, size_t nmemb, FILE *fp)</td></tr>
<tr class="memdesc:ga032c2a840544aee29ac1b36494bdfc6b"><td class="mdescLeft">&#160;</td><td class="mdescRight">Read binary file.  <a href="group__util.html#ga032c2a840544aee29ac1b36494bdfc6b">More...</a><br/></td></tr>
<tr class="separator:ga032c2a840544aee29ac1b36494bdfc6b"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:gad27678810eff89cf1f813631d762b298"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__util.html#gad27678810eff89cf1f813631d762b298">timlUtilFwrite</a> (const void *ptr, size_t size, size_t nmemb, FILE *fp)</td></tr>
<tr class="memdesc:gad27678810eff89cf1f813631d762b298"><td class="mdescLeft">&#160;</td><td class="mdescRight">Write to a binar file.  <a href="group__util.html#gad27678810eff89cf1f813631d762b298">More...</a><br/></td></tr>
<tr class="separator:gad27678810eff89cf1f813631d762b298"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:gafdc65cff28dd8132ee12d7e4fff6b344"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__util.html#gafdc65cff28dd8132ee12d7e4fff6b344">timlUtilConv2Valid</a> (float *a, float *b, float *c, int aRow, int aCol, int bRow, int bCol)</td></tr>
<tr class="memdesc:gafdc65cff28dd8132ee12d7e4fff6b344"><td class="mdescLeft">&#160;</td><td class="mdescRight">conv2(a, b, 'valid')  <a href="group__util.html#gafdc65cff28dd8132ee12d7e4fff6b344">More...</a><br/></td></tr>
<tr class="separator:gafdc65cff28dd8132ee12d7e4fff6b344"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga825fca95dc612cb50cca8d3b42fce451"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__util.html#ga825fca95dc612cb50cca8d3b42fce451">timlUtilConv2Full</a> (float *a, float *b, float *c, int aRow, int aCol, int bRow, int bCol)</td></tr>
<tr class="memdesc:ga825fca95dc612cb50cca8d3b42fce451"><td class="mdescLeft">&#160;</td><td class="mdescRight">conv2(a, b, 'full')  <a href="group__util.html#ga825fca95dc612cb50cca8d3b42fce451">More...</a><br/></td></tr>
<tr class="separator:ga825fca95dc612cb50cca8d3b42fce451"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga76c854493ff6e686e70caf0e0f330694"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__util.html#ga76c854493ff6e686e70caf0e0f330694">timlUtilCorr2Full</a> (float *a, float *b, float *c, int aRow, int aCol, int bRow, int bCol)</td></tr>
<tr class="memdesc:ga76c854493ff6e686e70caf0e0f330694"><td class="mdescLeft">&#160;</td><td class="mdescRight">conv2(a, rot90(b,2), 'valid')  <a href="group__util.html#ga76c854493ff6e686e70caf0e0f330694">More...</a><br/></td></tr>
<tr class="separator:ga76c854493ff6e686e70caf0e0f330694"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga823c056e72e3c9738ba07232a759dd93"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__util.html#ga823c056e72e3c9738ba07232a759dd93">timlUtilConv2ImageReshapeBack</a> (float *x, float *xReshape, int *index, int channel, int xDim, int indexDim, int deviceId, int threadId)</td></tr>
<tr class="memdesc:ga823c056e72e3c9738ba07232a759dd93"><td class="mdescLeft">&#160;</td><td class="mdescRight">Reshape the convolution matrix back to feature maps.  <a href="group__util.html#ga823c056e72e3c9738ba07232a759dd93">More...</a><br/></td></tr>
<tr class="separator:ga823c056e72e3c9738ba07232a759dd93"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga5bed0ba528735cfa363c12de22b30fae"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__util.html#ga5bed0ba528735cfa363c12de22b30fae">timlUtilConv2ImageReshapeIndex</a> (int *index, int aRow, int aCol, int bRow, int bCol, int padUp, int padDown, int padLeft, int padRight, int strideX, int strideY, timlUtilConvType type)</td></tr>
<tr class="memdesc:ga5bed0ba528735cfa363c12de22b30fae"><td class="mdescLeft">&#160;</td><td class="mdescRight">Create a reshaping index matrix.  <a href="group__util.html#ga5bed0ba528735cfa363c12de22b30fae">More...</a><br/></td></tr>
<tr class="separator:ga5bed0ba528735cfa363c12de22b30fae"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga1a6a5d975df7c8d4ef7ca184cbb98293"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__util.html#ga1a6a5d975df7c8d4ef7ca184cbb98293">timlUtilConv2ImageReshape</a> (float *xReshape, float *x, int *index, int channel, int xDim, int indexDim, int deviceId, int threadId)</td></tr>
<tr class="memdesc:ga1a6a5d975df7c8d4ef7ca184cbb98293"><td class="mdescLeft">&#160;</td><td class="mdescRight">Reshape feature maps to a format that turns 2d convolution to GEMM operation.  <a href="group__util.html#ga1a6a5d975df7c8d4ef7ca184cbb98293">More...</a><br/></td></tr>
<tr class="separator:ga1a6a5d975df7c8d4ef7ca184cbb98293"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga6e186bf4e96a71fd1bc88aa79a7fd7f9"><td class="memItemLeft" align="right" valign="top"><a class="el" href="structtimlUtilImage.html">timlUtilImage</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__util.html#ga6e186bf4e96a71fd1bc88aa79a7fd7f9">timlUtilReadJPEG</a> (const char *name)</td></tr>
<tr class="memdesc:ga6e186bf4e96a71fd1bc88aa79a7fd7f9"><td class="mdescLeft">&#160;</td><td class="mdescRight">read a jpg image  <a href="group__util.html#ga6e186bf4e96a71fd1bc88aa79a7fd7f9">More...</a><br/></td></tr>
<tr class="separator:ga6e186bf4e96a71fd1bc88aa79a7fd7f9"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga4e3a2beb9a301e6c71f5c1df09d6099e"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__util.html#ga4e3a2beb9a301e6c71f5c1df09d6099e">timlUtilReadFixedSizeJPEG</a> (const char *name, float *data, int row, int col, int channel)</td></tr>
<tr class="memdesc:ga4e3a2beb9a301e6c71f5c1df09d6099e"><td class="mdescLeft">&#160;</td><td class="mdescRight">Read a jpg image with known size information to avoid frequent allocation and deallocation of data.  <a href="group__util.html#ga4e3a2beb9a301e6c71f5c1df09d6099e">More...</a><br/></td></tr>
<tr class="separator:ga4e3a2beb9a301e6c71f5c1df09d6099e"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga3cb2f6d77b727af3d819f75c6918c327"><td class="memItemLeft" align="right" valign="top">char **&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__util.html#ga3cb2f6d77b727af3d819f75c6918c327">timlUtilScanJPEG</a> (const char *dirName, int *imageNum)</td></tr>
<tr class="memdesc:ga3cb2f6d77b727af3d819f75c6918c327"><td class="mdescLeft">&#160;</td><td class="mdescRight">Return an array of jpg image names in the directory.  <a href="group__util.html#ga3cb2f6d77b727af3d819f75c6918c327">More...</a><br/></td></tr>
<tr class="separator:ga3cb2f6d77b727af3d819f75c6918c327"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga365f20b5c810059087f2d24964ec7fdd"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="ga365f20b5c810059087f2d24964ec7fdd"></a>
void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__util.html#ga365f20b5c810059087f2d24964ec7fdd">timlUtilBLASdgemm</a> (const enum CBLAS_TRANSPOSE TransA, const enum CBLAS_TRANSPOSE TransB, const int M, const int N, const int K, const double alpha, const double *A, const double *B, const double beta, double *C, int deviceId, int threadId)</td></tr>
<tr class="memdesc:ga365f20b5c810059087f2d24964ec7fdd"><td class="mdescLeft">&#160;</td><td class="mdescRight">Double general matrix matrix multiplication C = alpha * op(A) * op(B) + beta * C op(A) : M*K op(B) : K*N. <br/></td></tr>
<tr class="separator:ga365f20b5c810059087f2d24964ec7fdd"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga3cd3b5eb20373a30eb06e1db3f27e105"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="ga3cd3b5eb20373a30eb06e1db3f27e105"></a>
void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__util.html#ga3cd3b5eb20373a30eb06e1db3f27e105">timlUtilBLASsgemm</a> (const enum CBLAS_TRANSPOSE TransA, const enum CBLAS_TRANSPOSE TransB, const int M, const int N, const int K, const float alpha, const float *A, const float *B, const float beta, float *C, int deviceId, int threadId)</td></tr>
<tr class="memdesc:ga3cd3b5eb20373a30eb06e1db3f27e105"><td class="mdescLeft">&#160;</td><td class="mdescRight">Float general matrix matrix multiplication C = alpha * op(A) * op(B) + beta * C op(A) : M*K op(B) : K*N. <br/></td></tr>
<tr class="separator:ga3cd3b5eb20373a30eb06e1db3f27e105"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga7f200e1630837f410457f12228a3f8e3"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="ga7f200e1630837f410457f12228a3f8e3"></a>
void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__util.html#ga7f200e1630837f410457f12228a3f8e3">timlUtilBLASdgemv</a> (const enum CBLAS_TRANSPOSE TransA, const int M, const int N, const double alpha, const double *A, const double *x, const double beta, double *y, int deviceId, int threadId)</td></tr>
<tr class="memdesc:ga7f200e1630837f410457f12228a3f8e3"><td class="mdescLeft">&#160;</td><td class="mdescRight">Double general matrix vector multiplication y = alpha * op(A) * x + beta * y op(A): M*N. <br/></td></tr>
<tr class="separator:ga7f200e1630837f410457f12228a3f8e3"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga916c002835a135384e25aa4eabe8fece"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="ga916c002835a135384e25aa4eabe8fece"></a>
void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__util.html#ga916c002835a135384e25aa4eabe8fece">timlUtilBLASsgemv</a> (const enum CBLAS_TRANSPOSE TransA, const int M, const int N, const float alpha, const float *A, const float *x, const float beta, float *y, int deviceId, int threadId)</td></tr>
<tr class="memdesc:ga916c002835a135384e25aa4eabe8fece"><td class="mdescLeft">&#160;</td><td class="mdescRight">Float general matrix vector multiplication y = alpha * op(A) * x + beta * y op(A): M*N. <br/></td></tr>
<tr class="separator:ga916c002835a135384e25aa4eabe8fece"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:gace6d95139cce2b66d468b65916d92103"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="gace6d95139cce2b66d468b65916d92103"></a>
void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__util.html#gace6d95139cce2b66d468b65916d92103">timlUtilBLASsaxpy</a> (const int N, const float alpha, const float *X, float *Y, int deviceId, int threadId)</td></tr>
<tr class="memdesc:gace6d95139cce2b66d468b65916d92103"><td class="mdescLeft">&#160;</td><td class="mdescRight">Float vector addition Y = alpha * X + Y. <br/></td></tr>
<tr class="separator:gace6d95139cce2b66d468b65916d92103"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga67a8b8821e100476544c39ebe3f7d88a"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="ga67a8b8821e100476544c39ebe3f7d88a"></a>
void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__util.html#ga67a8b8821e100476544c39ebe3f7d88a">timlUtilBLASdaxpy</a> (const int N, const double alpha, const double *X, double *Y, int deviceId, int threadId)</td></tr>
<tr class="memdesc:ga67a8b8821e100476544c39ebe3f7d88a"><td class="mdescLeft">&#160;</td><td class="mdescRight">Double vector addition Y = alpha * X + Y. <br/></td></tr>
<tr class="separator:ga67a8b8821e100476544c39ebe3f7d88a"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:gae2c99812143fb0697fad81b04c62545d"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="gae2c99812143fb0697fad81b04c62545d"></a>
void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__util.html#gae2c99812143fb0697fad81b04c62545d">timlUtilBLASscopy</a> (const int N, const float *X, float *Y, int deviceId, int threadId)</td></tr>
<tr class="memdesc:gae2c99812143fb0697fad81b04c62545d"><td class="mdescLeft">&#160;</td><td class="mdescRight">Float vector copy Y = X. <br/></td></tr>
<tr class="separator:gae2c99812143fb0697fad81b04c62545d"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga242d2f4bb422b71fa05aec4b8568bdc4"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="ga242d2f4bb422b71fa05aec4b8568bdc4"></a>
void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__util.html#ga242d2f4bb422b71fa05aec4b8568bdc4">timlUtilBLASdcopy</a> (const int N, const double *X, double *Y, int deviceId, int threadId)</td></tr>
<tr class="memdesc:ga242d2f4bb422b71fa05aec4b8568bdc4"><td class="mdescLeft">&#160;</td><td class="mdescRight">Double vector copy Y = X. <br/></td></tr>
<tr class="separator:ga242d2f4bb422b71fa05aec4b8568bdc4"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:gacdd02957d16d4ba4951f35c0e7fc5b30"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="gacdd02957d16d4ba4951f35c0e7fc5b30"></a>
void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__util.html#gacdd02957d16d4ba4951f35c0e7fc5b30">timlUtilBLASsger</a> (const int M, const int N, const float alpha, float *x, float *y, float *A, int deviceId, int threadId)</td></tr>
<tr class="memdesc:gacdd02957d16d4ba4951f35c0e7fc5b30"><td class="mdescLeft">&#160;</td><td class="mdescRight">Float vector outer product A = alpha*x*y' + A; x: M y: N. <br/></td></tr>
<tr class="separator:gacdd02957d16d4ba4951f35c0e7fc5b30"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga22f1d9ebb3a5745c3583860b42c8590a"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="ga22f1d9ebb3a5745c3583860b42c8590a"></a>
void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__util.html#ga22f1d9ebb3a5745c3583860b42c8590a">timlUtilBLASdger</a> (const int M, const int N, const double alpha, double *x, double *y, double *A, int deviceId, int threadId)</td></tr>
<tr class="memdesc:ga22f1d9ebb3a5745c3583860b42c8590a"><td class="mdescLeft">&#160;</td><td class="mdescRight">Double vector outer product A = alpha*x*y' + A; x: M y: N. <br/></td></tr>
<tr class="separator:ga22f1d9ebb3a5745c3583860b42c8590a"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga336682df712eb1342b16a00731b55e2c"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="ga336682df712eb1342b16a00731b55e2c"></a>
void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__util.html#ga336682df712eb1342b16a00731b55e2c">timlUtilBLASdscal</a> (const int N, const double alpha, double *X, int deviceId, int threadId)</td></tr>
<tr class="memdesc:ga336682df712eb1342b16a00731b55e2c"><td class="mdescLeft">&#160;</td><td class="mdescRight">Double vector scaling x = alpha * x. <br/></td></tr>
<tr class="separator:ga336682df712eb1342b16a00731b55e2c"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga7f2ccf0e4a749d484cd40b64d14a0bdb"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="ga7f2ccf0e4a749d484cd40b64d14a0bdb"></a>
void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__util.html#ga7f2ccf0e4a749d484cd40b64d14a0bdb">timlUtilBLASsscal</a> (const int N, const float alpha, float *X, int deviceId, int threadId)</td></tr>
<tr class="memdesc:ga7f2ccf0e4a749d484cd40b64d14a0bdb"><td class="mdescLeft">&#160;</td><td class="mdescRight">Float vector scaling x = alpha * x. <br/></td></tr>
<tr class="separator:ga7f2ccf0e4a749d484cd40b64d14a0bdb"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga4c8737cc28dfcafb340a06869cb06c6d"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__util.html#ga4c8737cc28dfcafb340a06869cb06c6d">timlUtilVectorResetFloat</a> (float *a, int m, float val, int deviceId, int threadId)</td></tr>
<tr class="memdesc:ga4c8737cc28dfcafb340a06869cb06c6d"><td class="mdescLeft">&#160;</td><td class="mdescRight">Reset a float vector.  <a href="group__util.html#ga4c8737cc28dfcafb340a06869cb06c6d">More...</a><br/></td></tr>
<tr class="separator:ga4c8737cc28dfcafb340a06869cb06c6d"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga105ed091f1ed14bc4542117639799727"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__util.html#ga105ed091f1ed14bc4542117639799727">timlUtilVectorResetInt</a> (int *a, int m, int val, int deviceId, int threadId)</td></tr>
<tr class="memdesc:ga105ed091f1ed14bc4542117639799727"><td class="mdescLeft">&#160;</td><td class="mdescRight">Reset an int vector.  <a href="group__util.html#ga105ed091f1ed14bc4542117639799727">More...</a><br/></td></tr>
<tr class="separator:ga105ed091f1ed14bc4542117639799727"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga50c739176cce0504f24f414d1abe03de"><td class="memItemLeft" align="right" valign="top">float&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__util.html#ga50c739176cce0504f24f414d1abe03de">timlUtilVectorSumFloat</a> (float *a, int n)</td></tr>
<tr class="memdesc:ga50c739176cce0504f24f414d1abe03de"><td class="mdescLeft">&#160;</td><td class="mdescRight">Calculate the sum of a float vector.  <a href="group__util.html#ga50c739176cce0504f24f414d1abe03de">More...</a><br/></td></tr>
<tr class="separator:ga50c739176cce0504f24f414d1abe03de"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:gadbfd41f459cef267ff705fbed1a684de"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__util.html#gadbfd41f459cef267ff705fbed1a684de">timlUtilVectorSortFloat</a> (float *a, int n)</td></tr>
<tr class="memdesc:gadbfd41f459cef267ff705fbed1a684de"><td class="mdescLeft">&#160;</td><td class="mdescRight">Sort an array in descending order.  <a href="group__util.html#gadbfd41f459cef267ff705fbed1a684de">More...</a><br/></td></tr>
<tr class="separator:gadbfd41f459cef267ff705fbed1a684de"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga7adedb39838d1a724329c2f05e70d2bc"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__util.html#ga7adedb39838d1a724329c2f05e70d2bc">timlUtilVectorSortIndexFloat</a> (float *a, int *index, int n)</td></tr>
<tr class="memdesc:ga7adedb39838d1a724329c2f05e70d2bc"><td class="mdescLeft">&#160;</td><td class="mdescRight">Sort an array in descending order and return the indices of the original elements in the sorted array.  <a href="group__util.html#ga7adedb39838d1a724329c2f05e70d2bc">More...</a><br/></td></tr>
<tr class="separator:ga7adedb39838d1a724329c2f05e70d2bc"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga80375ed4d8c895a5373c0ea5bea7c90c"><td class="memItemLeft" align="right" valign="top">float&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__util.html#ga80375ed4d8c895a5373c0ea5bea7c90c">timlUtilVectorMaxFloat</a> (float *x, int n, int inc)</td></tr>
<tr class="memdesc:ga80375ed4d8c895a5373c0ea5bea7c90c"><td class="mdescLeft">&#160;</td><td class="mdescRight">Return the max value in the array.  <a href="group__util.html#ga80375ed4d8c895a5373c0ea5bea7c90c">More...</a><br/></td></tr>
<tr class="separator:ga80375ed4d8c895a5373c0ea5bea7c90c"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga2e09d42235ce01dc8d951cac92ccce28"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__util.html#ga2e09d42235ce01dc8d951cac92ccce28">timlUtilVectorMaxIndexFloat</a> (float *x, int n, int inc)</td></tr>
<tr class="memdesc:ga2e09d42235ce01dc8d951cac92ccce28"><td class="mdescLeft">&#160;</td><td class="mdescRight">Return the max value index in the array.  <a href="group__util.html#ga2e09d42235ce01dc8d951cac92ccce28">More...</a><br/></td></tr>
<tr class="separator:ga2e09d42235ce01dc8d951cac92ccce28"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga4cbc9e168ae6fe4be792e5700078fbfd"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__util.html#ga4cbc9e168ae6fe4be792e5700078fbfd">timlUtilElementWiseMultiply</a> (float *a, const float *b, const float *c, int dim, int deviceId, int threadId)</td></tr>
<tr class="memdesc:ga4cbc9e168ae6fe4be792e5700078fbfd"><td class="mdescLeft">&#160;</td><td class="mdescRight">Element wise multiply c = a.*b.  <a href="group__util.html#ga4cbc9e168ae6fe4be792e5700078fbfd">More...</a><br/></td></tr>
<tr class="separator:ga4cbc9e168ae6fe4be792e5700078fbfd"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga158d5bed50c9d1aa04f3437ba4e4746c"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__util.html#ga158d5bed50c9d1aa04f3437ba4e4746c">timlUtilSubtract</a> (float *x, float y, int deviceId, int threadId)</td></tr>
<tr class="memdesc:ga158d5bed50c9d1aa04f3437ba4e4746c"><td class="mdescLeft">&#160;</td><td class="mdescRight">Subtract operation.  <a href="group__util.html#ga158d5bed50c9d1aa04f3437ba4e4746c">More...</a><br/></td></tr>
<tr class="separator:ga158d5bed50c9d1aa04f3437ba4e4746c"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga0e3ab1684d55ae10ec96b1b7a58c2d0f"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__util.html#ga0e3ab1684d55ae10ec96b1b7a58c2d0f">timlUtilSigmoid</a> (float *x, float *y, int n, int deviceId, int threadId)</td></tr>
<tr class="memdesc:ga0e3ab1684d55ae10ec96b1b7a58c2d0f"><td class="mdescLeft">&#160;</td><td class="mdescRight">Sigmoid.  <a href="group__util.html#ga0e3ab1684d55ae10ec96b1b7a58c2d0f">More...</a><br/></td></tr>
<tr class="separator:ga0e3ab1684d55ae10ec96b1b7a58c2d0f"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:gac4ce5d2a827d4d0bddb092604dc22555"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__util.html#gac4ce5d2a827d4d0bddb092604dc22555">timlUtilSigmoidDerivative</a> (float *x, float *y, int n, int deviceId, int threadId)</td></tr>
<tr class="memdesc:gac4ce5d2a827d4d0bddb092604dc22555"><td class="mdescLeft">&#160;</td><td class="mdescRight">Sigmoid derivative.  <a href="group__util.html#gac4ce5d2a827d4d0bddb092604dc22555">More...</a><br/></td></tr>
<tr class="separator:gac4ce5d2a827d4d0bddb092604dc22555"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:gaf61206d55b45c89e3382ed9684ef2c79"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__util.html#gaf61206d55b45c89e3382ed9684ef2c79">timlUtilRelu</a> (float *x, float *y, int n, int deviceId, int threadId)</td></tr>
<tr class="memdesc:gaf61206d55b45c89e3382ed9684ef2c79"><td class="mdescLeft">&#160;</td><td class="mdescRight">Rectified linear unit.  <a href="group__util.html#gaf61206d55b45c89e3382ed9684ef2c79">More...</a><br/></td></tr>
<tr class="separator:gaf61206d55b45c89e3382ed9684ef2c79"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:gadcb6e562a1ddebb9589dc326c6e85db3"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__util.html#gadcb6e562a1ddebb9589dc326c6e85db3">timlUtilReluDerivative</a> (float *x, float *y, int n, int deviceId, int threadId)</td></tr>
<tr class="memdesc:gadcb6e562a1ddebb9589dc326c6e85db3"><td class="mdescLeft">&#160;</td><td class="mdescRight">Rectified linear unit derivative.  <a href="group__util.html#gadcb6e562a1ddebb9589dc326c6e85db3">More...</a><br/></td></tr>
<tr class="separator:gadcb6e562a1ddebb9589dc326c6e85db3"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga680fe5b84f1ce4712c74fc9c01b5dc82"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__util.html#ga680fe5b84f1ce4712c74fc9c01b5dc82">timlUtilTanhDerivative</a> (float *x, float *y, int n, int deviceId, int threadId)</td></tr>
<tr class="memdesc:ga680fe5b84f1ce4712c74fc9c01b5dc82"><td class="mdescLeft">&#160;</td><td class="mdescRight">Tanh derivative.  <a href="group__util.html#ga680fe5b84f1ce4712c74fc9c01b5dc82">More...</a><br/></td></tr>
<tr class="separator:ga680fe5b84f1ce4712c74fc9c01b5dc82"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:gac8848759ff2638e9b54beef8f82748ae"><td class="memItemLeft" align="right" valign="top">float&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__util.html#gac8848759ff2638e9b54beef8f82748ae">timlUtilMultinomialCrossEntropy</a> (float *x, int label, int n)</td></tr>
<tr class="memdesc:gac8848759ff2638e9b54beef8f82748ae"><td class="mdescLeft">&#160;</td><td class="mdescRight">Calculate the mutlinomial cross entropy between x and label.  <a href="group__util.html#gac8848759ff2638e9b54beef8f82748ae">More...</a><br/></td></tr>
<tr class="separator:gac8848759ff2638e9b54beef8f82748ae"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga8e17bdb2dd7b9e8f25d1a93c8d470a97"><td class="memItemLeft" align="right" valign="top">float&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__util.html#ga8e17bdb2dd7b9e8f25d1a93c8d470a97">timlUtilMeanSqaureError</a> (float *x, int label, int n)</td></tr>
<tr class="memdesc:ga8e17bdb2dd7b9e8f25d1a93c8d470a97"><td class="mdescLeft">&#160;</td><td class="mdescRight">Calculate the mean square error between x and label.  <a href="group__util.html#ga8e17bdb2dd7b9e8f25d1a93c8d470a97">More...</a><br/></td></tr>
<tr class="separator:ga8e17bdb2dd7b9e8f25d1a93c8d470a97"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga223537dde56b8c21a9455ff8a635f71f"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__util.html#ga223537dde56b8c21a9455ff8a635f71f">timlUtilSoftmax</a> (float *x, float *y, int row, int col, int channel, int deviceId, int threadId)</td></tr>
<tr class="memdesc:ga223537dde56b8c21a9455ff8a635f71f"><td class="mdescLeft">&#160;</td><td class="mdescRight">Softmax function.  <a href="group__util.html#ga223537dde56b8c21a9455ff8a635f71f">More...</a><br/></td></tr>
<tr class="separator:ga223537dde56b8c21a9455ff8a635f71f"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga64e5197e9d131870e97cd510b3f499ac"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__util.html#ga64e5197e9d131870e97cd510b3f499ac">timlUtilClassifyAccuracy</a> (int *label, int topN, int num, int *trueLabel)</td></tr>
<tr class="memdesc:ga64e5197e9d131870e97cd510b3f499ac"><td class="mdescLeft">&#160;</td><td class="mdescRight">Calculate the classification accuracy.  <a href="group__util.html#ga64e5197e9d131870e97cd510b3f499ac">More...</a><br/></td></tr>
<tr class="separator:ga64e5197e9d131870e97cd510b3f499ac"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga6bc3609f73f6674134821cc002d7081f"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__util.html#ga6bc3609f73f6674134821cc002d7081f">timlUtilTransform</a> (float *dataOut, float *dataIn, float *dataHost, int channel, int row, int col, int rowOffset, int colOffset, int rowIn, int colIn, float scale, float *mean, <a class="el" href="group__util.html#ga5405b012e02035f4d864e0e38d516764">timlUtilMirrorType</a> mirrorType, int deviceId, int threadId)</td></tr>
<tr class="memdesc:ga6bc3609f73f6674134821cc002d7081f"><td class="mdescLeft">&#160;</td><td class="mdescRight">Transform the raw input data with preprocessing.  <a href="group__util.html#ga6bc3609f73f6674134821cc002d7081f">More...</a><br/></td></tr>
<tr class="separator:ga6bc3609f73f6674134821cc002d7081f"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:gac9523e1013f8e3853568eb2e67b54a58"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__util.html#gac9523e1013f8e3853568eb2e67b54a58">timlUtilMaxPooling</a> (float *outputMap, int *maxIndex, float *inputMap, int row, int col, int channel, int prevRow, int prevCol, int scaleRow, int scaleCol, int padUp, int padLeft, int strideX, int strideY, timlUtilPhase phase, int deviceId, int threadId)</td></tr>
<tr class="memdesc:gac9523e1013f8e3853568eb2e67b54a58"><td class="mdescLeft">&#160;</td><td class="mdescRight">Max pooling.  <a href="group__util.html#gac9523e1013f8e3853568eb2e67b54a58">More...</a><br/></td></tr>
<tr class="separator:gac9523e1013f8e3853568eb2e67b54a58"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:gae073107f6b111717bac95417ff80c85c"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__util.html#gae073107f6b111717bac95417ff80c85c">timlUtilUndoMaxPooling</a> (float *prevDelta, int *maxIndex, float *delta, int dim, int deviceId, int threadId)</td></tr>
<tr class="memdesc:gae073107f6b111717bac95417ff80c85c"><td class="mdescLeft">&#160;</td><td class="mdescRight">Undo max pooling.  <a href="group__util.html#gae073107f6b111717bac95417ff80c85c">More...</a><br/></td></tr>
<tr class="separator:gae073107f6b111717bac95417ff80c85c"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga8d4338ebfb64ecb3ec88094aebd65e40"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__util.html#ga8d4338ebfb64ecb3ec88094aebd65e40">timlUtilMeanPooling</a> (float *outputMap, float *inputMap, int row, int col, int channel, int prevRow, int prevCol, int scaleRow, int scaleCol, int padUp, int padLeft, int strideX, int strideY, int deviceId, int threadId)</td></tr>
<tr class="memdesc:ga8d4338ebfb64ecb3ec88094aebd65e40"><td class="mdescLeft">&#160;</td><td class="mdescRight">Mean pooling.  <a href="group__util.html#ga8d4338ebfb64ecb3ec88094aebd65e40">More...</a><br/></td></tr>
<tr class="separator:ga8d4338ebfb64ecb3ec88094aebd65e40"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga47ba59c5e11f31931e3fae5717b93450"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__util.html#ga47ba59c5e11f31931e3fae5717b93450">timlUtilUndoMeanPooling</a> (float *prevDelta, float *delta, int row, int col, int channel, int prevRow, int prevCol, int scaleRow, int scaleCol, int padUp, int padLeft, int strideX, int strideY, int deviceId, int threadId)</td></tr>
<tr class="memdesc:ga47ba59c5e11f31931e3fae5717b93450"><td class="mdescLeft">&#160;</td><td class="mdescRight">Undo mean pooling.  <a href="group__util.html#ga47ba59c5e11f31931e3fae5717b93450">More...</a><br/></td></tr>
<tr class="separator:ga47ba59c5e11f31931e3fae5717b93450"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga1d68b304f7ad43899cf5a2762a0a49fc"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__util.html#ga1d68b304f7ad43899cf5a2762a0a49fc">timlUtilLocalContrastNormalize</a> (float *inputMap, float *outputMap, float *denom, int row, int col, int channel, int N, float alpha, float beta, int deviceId, int threadId)</td></tr>
<tr class="memdesc:ga1d68b304f7ad43899cf5a2762a0a49fc"><td class="mdescLeft">&#160;</td><td class="mdescRight">Local contrast normalization.  <a href="group__util.html#ga1d68b304f7ad43899cf5a2762a0a49fc">More...</a><br/></td></tr>
<tr class="separator:ga1d68b304f7ad43899cf5a2762a0a49fc"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga684bafa4cb678d451ec1aa5127007470"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__util.html#ga684bafa4cb678d451ec1aa5127007470">timlUtilLocalContrastUnnormalize</a> (float *prevDelta, float *prevFeatureMap, float *delta, float *featureMap, float *denom, int row, int col, int channel, int N, float alpha, float beta, int deviceId, int threadId)</td></tr>
<tr class="memdesc:ga684bafa4cb678d451ec1aa5127007470"><td class="mdescLeft">&#160;</td><td class="mdescRight">Local contrast unnormalization.  <a href="group__util.html#ga684bafa4cb678d451ec1aa5127007470">More...</a><br/></td></tr>
<tr class="separator:ga684bafa4cb678d451ec1aa5127007470"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga4b2ab842a2212e924deb9f60bf1b703e"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__util.html#ga4b2ab842a2212e924deb9f60bf1b703e">timlUtilMasking</a> (float *inputMap, float *outputMap, int *mask, unsigned int *randomVector, int dim, float prob, int deviceId, int threadId)</td></tr>
<tr class="memdesc:ga4b2ab842a2212e924deb9f60bf1b703e"><td class="mdescLeft">&#160;</td><td class="mdescRight">Masking feature maps.  <a href="group__util.html#ga4b2ab842a2212e924deb9f60bf1b703e">More...</a><br/></td></tr>
<tr class="separator:ga4b2ab842a2212e924deb9f60bf1b703e"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga7e53789a132ed94665d66a10dd9ff76c"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__util.html#ga7e53789a132ed94665d66a10dd9ff76c">timlUtilUnmasking</a> (float *inputDelta, float *outputDelta, int *mask, int dim, float prob, int deviceId, int threadId)</td></tr>
<tr class="memdesc:ga7e53789a132ed94665d66a10dd9ff76c"><td class="mdescLeft">&#160;</td><td class="mdescRight">Masking feature maps.  <a href="group__util.html#ga7e53789a132ed94665d66a10dd9ff76c">More...</a><br/></td></tr>
<tr class="separator:ga7e53789a132ed94665d66a10dd9ff76c"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga26bb1805bd3475719324718c12cd5a0f"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__util.html#ga26bb1805bd3475719324718c12cd5a0f">timlUtilTanh</a> (float *x, float *y, int n, int deviceId, int threadId)</td></tr>
<tr class="memdesc:ga26bb1805bd3475719324718c12cd5a0f"><td class="mdescLeft">&#160;</td><td class="mdescRight">Tanh.  <a href="group__util.html#ga26bb1805bd3475719324718c12cd5a0f">More...</a><br/></td></tr>
<tr class="separator:ga26bb1805bd3475719324718c12cd5a0f"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga432784c912b542452d7236cf72d184fe"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__util.html#ga432784c912b542452d7236cf72d184fe">timlUtilMalloc</a> (void **devPtr, size_t size)</td></tr>
<tr class="memdesc:ga432784c912b542452d7236cf72d184fe"><td class="mdescLeft">&#160;</td><td class="mdescRight">memory allocation  <a href="group__util.html#ga432784c912b542452d7236cf72d184fe">More...</a><br/></td></tr>
<tr class="separator:ga432784c912b542452d7236cf72d184fe"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga234f6573583aca626c49e10b1f5b57d2"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__util.html#ga234f6573583aca626c49e10b1f5b57d2">timlUtilFree</a> (void *ptr)</td></tr>
<tr class="memdesc:ga234f6573583aca626c49e10b1f5b57d2"><td class="mdescLeft">&#160;</td><td class="mdescRight">Free pointer.  <a href="group__util.html#ga234f6573583aca626c49e10b1f5b57d2">More...</a><br/></td></tr>
<tr class="separator:ga234f6573583aca626c49e10b1f5b57d2"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga16f8b9181ff6ce6d4b1f655a5eb4738e"><td class="memItemLeft" align="right" valign="top">uint32_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__util.html#ga16f8b9181ff6ce6d4b1f655a5eb4738e">timlUtilReverseEndian32</a> (register uint32_t i)</td></tr>
<tr class="memdesc:ga16f8b9181ff6ce6d4b1f655a5eb4738e"><td class="mdescLeft">&#160;</td><td class="mdescRight">Reverse the 32 bit endian pattern.  <a href="group__util.html#ga16f8b9181ff6ce6d4b1f655a5eb4738e">More...</a><br/></td></tr>
<tr class="separator:ga16f8b9181ff6ce6d4b1f655a5eb4738e"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga71557afaf0c3d8359920380558dd92fb"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__util.html#ga71557afaf0c3d8359920380558dd92fb">timlUtilElementWiseFunction</a> (float *x, float *y, int n, float(*func)(float))</td></tr>
<tr class="memdesc:ga71557afaf0c3d8359920380558dd92fb"><td class="mdescLeft">&#160;</td><td class="mdescRight">Apply a function on each element of the array.  <a href="group__util.html#ga71557afaf0c3d8359920380558dd92fb">More...</a><br/></td></tr>
<tr class="separator:ga71557afaf0c3d8359920380558dd92fb"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
</div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated on Fri Mar 20 2015 11:26:08 for TIML by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.6
</small></address>
</body>
</html>
